"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cachedFn = exports.assertNever = void 0;
function assertNever(value) {
    throw new Error(`Invalid value: ${value}`);
}
exports.assertNever = assertNever;
function cachedFn(fn) {
    const cache = new WeakMap();
    return (key) => {
        let cached = cache.get(key);
        if (cached === undefined) {
            cached = fn(key);
            cache.set(key, cached);
        }
        return cached;
    };
}
exports.cachedFn = cachedFn;
